 /*
     Graph
      
    A graph that will hold the nodes.
     
   */
public class Graph
{
   public int vertices;
   Node[] nodes = null;
   int size = 0;

   /**
       Builds an adjacency list graph object capable of managing <i>vertices</i>
       many vertices

       @param vertices : number of vertices that can be in the graph
    */
   public Graph (int vertices)
   {
       this.vertices = vertices;
       nodes = new Node[this.vertices];
   }

   /*
     addVertex(Node node)
     
     Adds a new vertex to the graph
      
     @param node : node to be added
     
    */
   public void addVertex(Node node)
   {
       this.nodes[size] = node;
       size++;
   }

   /*
     returnNode(int  pos)
     
     Returns a node of a certain value.
      
     @param pos : the integer value of the node to be returned
    */
   public Node returnNode(int pos)
   {
      Node node = null;
      for(int i = 0; i < nodes.length; i++)
      {
         if(pos == nodes[i].position)
         {
            node = nodes[i];
         }
      }
      
      return node;
   }

}
