/*
    Node
    A single node to be help in th graph
*/
public class Node
{
   public int position;
   int degree;
   Color color;
   public Boolean edge;
   public int discovered;
   public int finished;
   public int time;
   Node parent;
   
   public enum Color
   {
      White, Gray, Black
   }
   
   Node[] adjNodes = null;

   /**
      Node(int pos)

      creates a node with the give position

      @param pos : position to use for the node
    */
   public Node(int pos)
   {
      position = pos;
      color = Color.White;
      edge = true;
      degree = 0;
      discovered = 0;
      finished = 0;
      time = 0;
      parent = null;
   }
   
   /**
      addAdjNode(Node node)

      Adds a node to a adjecency list that the super node connects to.

      @param node : node to be added

   */
   public void addAdjNode(Node child)
   {
      
      if(adjNodes == null)
      {
         adjNodes = new Node[1];
         this.setEdge(false);
      }
      else
      {
         Node[] tmp = adjNodes;
         this.adjNodes = new Node[degree+ 1];
         copy(tmp);
      }
      child.parent = this;
      adjNodes[degree] = child;
      degree++;
   }
   
   /**
      copy(Node node)

      Copyies the adjecency nodes

      @param node : node to be added

   */
   void copy(Node[] array)
   {
      for(int i =0; i < array.length;i++)
      {
         this.adjNodes[i] = array[i];
      }
   }

   /**
      setInDegree(int inDegree)

      sets the degree of curent node

      @param degree : node degree

   */
   public void setInDegree(int inDegree) 
   {
      this.degree = inDegree;
   }

   /**
      getInDegree()

      @return in degree of the node

   */
   public int getInDegree() 
   {
    return degree;
   }
   /**
      setEdge(Boolean bool)

      sets the edge to true or fail

      @param bool value to set to
   */
   public void setEdge(Boolean bool)
   {
      this.edge = bool;
   }
   
   /**
      toString()

      returns position of the node

      @return position : node position

   */
   @Override
   public String toString()
   {
      return   position + " ";
   }
}
